// Groebner bases and normal forms: repeating

ring r = 0,(z,y,x),lp;

//Example 2.1

ideal I1 = 4*z - 4*x*y2 - 16*x2 - 1, 2*y2*z + 4*x + 1, 2*x2*z + 2*y2 + x;

// "...we want to decide whether the additional relation follows from above "

poly g = 4*x*y4 + 16*x2*y2 + y2 + 8*x + 2;

// leading functions:

leadmonom(g);

leadcoef(g);

leadexp(g);

lead(g);

reduce(g,I1); // I1 is not a GB!

ideal J = std(I1);

reduce(g, J);

// we are interested in solving in terms of algebraic data

ideal I2 = 4*x*z - 4*x*y2 - 16*x2 - 1, 2*y2*z + 4*x + 1, 2*x2*z + 2*y2 + x;

ideal K = std(I2); // K[1] is in x only

factorize(K[1]);

ring r2 = (0,x),(z,y),lp;

minpoly = 1/32*(32*x5-216*x^4+64*x^3-42*x^2+32*x+5);

ideal I = imap(r,K);

I = groebner(I); 

LIB "poly.lib";

I = normalize(I); // i.e. make leading coeffs 1

// what about algebraic and real roots?

setring r;

LIB "rootsmr.lib";

nrRootsProbab(K); // gives just two real roots

vdim(K); // number of complex roots

LIB "solve.lib";

def S = solve(K,10); // solve the system numerically

setring S; 

SOL[1];  //real root

SOL[2]; //real root
