LIB "bfun.lib";

proc mysection(ideal I, int n)
{
  if ( (n<=0) || (n>nvars(basering)) )
  {
    ERROR("2nd argument out of range");
  }
  if (attrib(I,"isSB")==0)
  {
    "warning: compute Groebner basis of I";
    I = groebner(I);
  }
  if (dim(I) >0)
  {
    ERROR("The input ideal is not 0 dimensional");
  }
  poly q = vec2poly(pIntersect(var(n),I),n);
  return(q);
};


ring r = 0,(x,y,z),dp;

//Example 2.1

ideal I = 4*z - 4*x*y2 - 16*x2 - 1, 2*y2*z + 4*x + 1, 2*x2*z + 2*y2 + x;

mysection(I,3); // ok, let's compute GB of I. degree 7

I = groebner(I);

mysection(I,2); // degree 14 !

mysection(I,1); // degree 7

ideal J = 4*x*z - 4*x*y2 - 16*x2 - 1, 2*y2*z + 4*x + 1, 2*x2*z + 2*y2 + x;

J = groebner(J);

// exercise: compute the intersections and check whether they factorize!

